/* fmu.c:  FLASH management utilitly.
 *
 * (c) 1996, Dionne & Associates
 * This is free software, under the GPL v2.
 */

#include "srec.h"

erase()
{
  int i;

  puts ("Erasing Flash");
  for (i=7;i;i--) {

    *(unsigned volatile char *)0x25555=0x0aa;
    *(unsigned volatile char *)0x22aaa=0x055;
    *(unsigned volatile char *)0x25555=0x080;
    *(unsigned volatile char *)0x25555=0x0aa;
    *(unsigned volatile char *)0x22aaa=0x055;

    *(unsigned volatile char *)(0x21234 + 0x4000 * i)=0x030;
    while (!((*(unsigned volatile char *)0x1fffc) & 0x80));

    putchar('.');
  }

  puts("\n\rFlash erased");

  return 0;
}

program_byte(int addr,unsigned char data)
{
  int t;

  *(unsigned volatile char *)0x25555=0x0aa;
  *(unsigned volatile char *)0x22aaa=0x055;
  *(unsigned volatile char *)0x25555=0x0a0;
  *(unsigned volatile char *)(0x20000 + addr)=data;

  for (t = 0; t < 100000; t--) {
    if (((*(unsigned volatile char *)addr) & 0xff) == (data & 0xff)) {
      return 0;
    }
  }
  puts("write failed!");
  return -1;
}

program_record(SRBIN *sb)
{
  int cnt;

  for (cnt = 0;cnt < sb->count; cnt++) {
    if (program_byte(sb->addr + cnt,sb->data[cnt])) {
      return -1;
    }
  }
  return 0;
}

main()
{
  SRTEXT sr;
  SRBIN sb;
  char *p;

  open();

  while (1) {

    p = (char *)&sr;

    while(((*(p++)) = getchar()) != '\r');
    *(--p) = 0;

    if (*(char *)(&sr) == 'B') {
      unsigned int addr;
      unsigned char data;

      addr =chex(((char*)&sr)+1, 8, (void *)0);
      data =chex(((char*)&sr)+9, 2, (void *)0);
      program_byte(addr, data);
      putchar('#');
      continue;
    }

    if (*(char *)(&sr) == 'E') {
      erase();
      continue;
    }

    if (*(char *)(&sr) == 'R') {
      asm("jmp 0x0e");
      puts("Reset failed");
    }

    if (*(char *)(&sr) == 'S') {
      if (srec(&sr,&sb) == -1) {
	putchar('!');
      } else {
	putchar('.');
	if (sb.addr < 0x20000) program_record(&sb);
	else puts("Address not in FLASH");
	putchar('#');
      }
      continue;
    }
    puts("Huh?");
  }
}
