/*
 * Simple open. Hardwired for 9600
 */

#define QSMCR *(volatile unsigned short *)0xfffc00
#define QILR *(volatile unsigned short *)0xfffc04
#define SYNCR *(volatile unsigned short *)0xfffa04
#define SCCR0 *(volatile unsigned short *)0xfffc08
#define SCCR1 *(volatile unsigned short *)0xfffc0a
#define SCSR *(volatile unsigned short *)0xfffc0c
#define SCDR *(volatile unsigned short *)0xfffc0e
#define FREF 32768

int open(int dummy)
{
  unsigned int sysclock;

  sysclock = FREF * 4 *(((SYNCR & 0x3f00)>>8) +1)*(1<<((SYNCR & 0xc000)>>14));
  SCCR0 = sysclock / (32 * 9600);

  SCCR1 = 0x100c; /* 8n1, interrupts off */
}

/*
 * Simple synchronus polled I/O. putchar & getchar
 */

int putchar(int ch)
{
  while (!(SCSR & 0x0100));
  SCDR = ch;
  while (!(SCSR & 0x0100)); /* wait for the char to actually go */
}

int getchar()
{
  while (!(SCSR & 0x0040));
  return SCDR;
}

char *gets(char *buf)
{
  while ((*buf = getchar()) != '\r') {
    putchar (*(buf++));
  }
  *buf = 0;
  return buf;
}

puts(char *buf)
{
  while (*buf) putchar (*(buf++));
  putchar ('\n');
  putchar ('\r');
}
