#include <string.h>

int sh(int argc, char *argv[]);
int bload(int argc, char *argv[]);

typedef struct comtab {
  int (*fcn)();
  char cmd[10];
} COMTAB;

static COMTAB comtab[] = {
  {&sh, "sh"},
  {&bload, "fmu"},
  { (void *)0 ,""}
};

extern char idstring[];

static char *strparse(char **next, char *src)
{
  char *p;
  while (*src == ' ') {
    if (!(*src)) {
      return (char *)0;
    }
    src++;
  }
  p = src;
  while ((*src != ' ') && *(src++));
  *(src++) = 0;
  *next = src;
  return p;
}

static int comidx(char *str)
{
  int idx = 0;

  while (comtab[idx].fcn) {
    if (!strcmp(comtab[idx].cmd,str)) return idx;

    idx++;
  }
  return -1;
}

int sh(int argc, char *argv[])
{
  char buf[80];
  char *args[6];
  char *next;
  char *bufend;
  int command;
  int i;

  if (argc > 1) {
    puts ("\n\rFLASH management utility-0.1.2");
  }

  /* main loop. */

  while (1) {
    putchar('f');
    putchar('m');
    putchar('u');
    putchar('>');
    putchar(' ');

    gets(buf);
    puts("");
    bufend = buf + strlen(buf);

    i = 0;
    next = buf;

    while (next < bufend) {
      args[i] = strparse(&next, next);

      if (!strcmp(";",args[i++]) || !(next < bufend)) {

	if (!strcmp("exit",args[0])) return;

	if (*args[0] != '\n' && *args[0] != '\r' && strlen(args[0])) {
	  if ((command = comidx(args[0])) == -1) {
	    puts("sh: command not found.");
	  }
	  else {

	    args[i] = (void *)0;

	    comtab[command].fcn(0,(void *) 0);

	    i = 0;
	  }
	}
      }
    }
  }
}
