/* loader.c: A comm program to load Srecords into FLASH over serial
 *
 * (c) 1996 Dionne & Associates,
 * This is free software, under the GNU public license v2 or greater
 */

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>

main(int argc, char *argv[])
{
  int fd;
  char buf[82];
  char ret = 0;
  int e;

  if (argc < 2) {
    printf ("Usage: %s </dev/tty???> [-k]\nReads srecords from stdin\nIf -k is specified, write the key also\n",argv[0]);
    exit (1);
  }

  if (!(fd = open(argv[1],O_RDWR))) {
    printf ("%s: cannot open %s\n",argv[0],argv[1]);
    exit (2);
  }

  while (gets(buf)) {
    write(fd,buf,strlen(buf));

    ret = 0;
    while (ret != '#' && ret != '!') {
      putchar (ret);
      if (!read(fd,&ret,1)) {
	puts("Oops! got 0!");
	exit(3);
      }
    }
    fflush(stdout);

    if (ret == '#');
    else {
      putchar('!');
      fflush(stdout);
    }
  }
  if (argc > 2) {
    puts("");
    puts("Writing key...");
    write(fd,"S3090001FFFCDEADBEEFC2\n\r",strlen("S3090001FFFCDEADBEEFC2\n\r"));
  }
  puts("");
  puts("Done.");
}
